install 10 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385
  1. #!/bin/bash
  2. #################################################################
  3. # auto-mediawiki #
  4. # Instala un servidor LAMP (Linux+Apache+MySQL+PHP) e instala #
  5. # MediaWiki y lo configura. #
  6. # #
  7. # Guzman Castanedo Villalba (guzman@castanedo.es) Junio 2018 #
  8. # GPLv3 (https://www.gnu.org/licenses/gpl.html) #
  9. #################################################################
  10. OSInfo() {
  11. #printf "Detectando SO..."
  12. debianOS=false
  13. rhelOS=false
  14. OS=$(uname -s)
  15. if [ $OS = "Linux" ]; then
  16. OS="GNU/Linux"
  17. if [ -f /etc/os-release ]; then
  18. DIST=$(grep ^NAME= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  19. REV=$(grep ^VERSION= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  20. ID_LIKE=$(grep ^ID_LIKE= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  21. for i in $ID_LIKE; do
  22. #printf "$i\n"
  23. case $i in
  24. debian|ubuntu)
  25. debianOS=true
  26. break
  27. ;;
  28. rhel|fedora)
  29. rhelOS=true
  30. break
  31. ;;
  32. *)
  33. debianOS=false
  34. rhelOS=false
  35. ;;
  36. esac
  37. done
  38. elif [ -f /etc/debian-version ]; then
  39. # Familia Debian (Debian, Ubuntu, Linux Mint, ...)
  40. DIST="Debian"
  41. REV=""
  42. ID_LIKE="debian"
  43. debianOS=true
  44. elif [ -f /etc/redhat-release ]; then
  45. # Familia Red-Hat (RHEL, Fedora, CentOS, ...)
  46. DIST="Red-Hat"
  47. REV=""
  48. ID_LIKE="rhel"
  49. rhelOS=true
  50. else
  51. # Other Linux (No Soportado)
  52. DIST=""
  53. REV=""
  54. ID_LIKE=""
  55. fi
  56. else
  57. # UNIX, OS X, ... (No Soportado)
  58. DIST=$OS
  59. REV=""
  60. fi
  61. #printf " $DIST $REV\n"
  62. HDInfo=$(df -h | head -1)"\n"$(df -h | grep ^/dev/sd)"\n"$(df -h | grep ^/dev/mapper)
  63. }
  64. comprobarRoot() {
  65. if [ $(id -u) -ne 0 ]; then
  66. printf "ERROR:\tEs necesario ser root ('sudo $0').\n"
  67. exit 1
  68. fi
  69. }
  70. comprobarDependencias() {
  71. which whiptail > /dev/null 2>&1
  72. if [ $? -ne 0 ];then
  73. printf "ERROR:\t'whiptail' no disponible.\n"
  74. exit 1
  75. fi
  76. which hostnamectl > /dev/null 2>&1
  77. if [ $? -ne 0 ];then
  78. printf "ERROR:\t'hostnamectl' no disponible.\n"
  79. exit 1
  80. fi
  81. if [ $debianOS = true ];then
  82. which apt-get > /dev/null 2>&1
  83. if [ $? -ne 0 ]; then
  84. printf "ERROR:\t'apt-get' no está disponible.\n"
  85. exit 1
  86. fi
  87. #Actualizamos base de datos del repositorio
  88. printf "Actualizando repositorio APT..."
  89. result=$(apt-get -q -y update)
  90. if [ $? -ne 0 ]; then
  91. printf "\nERROR:\tImposible actualizar repositorio.\n"
  92. printf "Detalles:\n$result\n"
  93. exit 1
  94. fi
  95. printf " OK.\n"
  96. fi
  97. if [ $rhelOS = true ]; then
  98. which yum > /dev/null 2>&1
  99. if [ $? -ne 0 ]; then
  100. printf "ERROR:\t'yum' no está disponible.\n"
  101. exit 1
  102. fi
  103. printf "Actualizando repositorio YUM..."
  104. result=$(yum -y makecache 2>&1)
  105. if [ $? -ne 0 ]; then
  106. printf "\nERROR:\tImposible actualizar repositorio.\n"
  107. printf "Detalles:\n$result\n"
  108. exit 1
  109. fi
  110. printf " OK.\n"
  111. fi
  112. }
  113. comprobarHostname() {
  114. while [ -z $hostname ]; do
  115. hostname=$(whiptail --title "Hostname" --inputbox "El nombre de dominio de este servidor es:\n"$(hostname)"\n\nQuieres cambiarlo por otro?" --ok-button "Cambiar" --cancel-button "No Cambiar" 20 70 3>&1 1>&2 2>&3)
  116. if [ $? -eq 0 ] && [ ! -z $hostname ]; then
  117. hostnamectl set-hostname $hostname
  118. else
  119. hostname=$(hostname)
  120. fi
  121. done
  122. #printf "\nHostname: $hostname\n"
  123. }
  124. mostrarBienvenida() {
  125. if [ $debianOS = false ] && [ $rhelOS = false ]; then
  126. whiptail --title "ERROR OS NO SOPORTADO" --msgbox "Este script automatiza la creación de una web MediaWiki SOLO para distribuciones Linux de la familia Debian (Ubuntu, Linux Mint, ...) y de la familia Red-Hat (CentOS, Fedora, ...).\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" --ok-button "Salir" 20 70
  127. exit 1
  128. fi
  129. whiptail --title "Instalación MediaWiki" --yesno "Este script automatiza completamente la instalación de una wiki.\nPara ello instala un servidor LAMP, el software MediaWiki y lo configura todo.\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" --yes-button "Continuar" --no-button "Salir" 20 70
  130. if [ $? -ne 0 ]; then
  131. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  132. exit 2
  133. fi
  134. }
  135. mostrarComponentes() {
  136. componentes=$(whiptail --title "Instalación" --checklist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge los componentes que quieres instalar:" 20 70 6 \
  137. "WebServer" "Instalar servidor web http/https" ON \
  138. "Database" "Instalar una base de datos SQL" ON \
  139. "PHP" "Instala PHP7" ON \
  140. "SSL/TLS" "Instalar certificados para activar HTTPS" ON \
  141. "MediaWiki" "Instalar wiki con MediaWiki" ON \
  142. "Moodle" "Instalar campus virtual con Moodle" ON \
  143. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  144. if [ $? -ne 0 ]; then
  145. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  146. exit 2
  147. fi
  148. # Mejora: autodetección de componentes ya instalados
  149. for i in $componentes; do
  150. case $i in
  151. \"WebServer\")
  152. printf "Instalando Servidor Web"
  153. instalarWebServer
  154. printf " OK.\n"
  155. ;;
  156. \"Database\")
  157. printf "Instalando Servidor Database"
  158. instalarDatabase
  159. printf " OK.\n"
  160. ;;
  161. \"PHP\")
  162. printf "Instalando PHP..."
  163. printf " OK.\n"
  164. ;;
  165. \"SSL/TLS\")
  166. printf "Instalando SSL/TLS..."
  167. printf " OK.\n"
  168. ;;
  169. \"MediaWiki\")
  170. printf "Instalando MediaWiki..."
  171. printf " OK.\n"
  172. ;;
  173. \"Moodle\")
  174. printf "Instalando Moodle..."
  175. printf " OK.\n"
  176. ;;
  177. *)
  178. printf "ERROR:\tError interno (selección de componentes).\n"
  179. exit 1
  180. ;;
  181. esac
  182. done
  183. }
  184. instalarWebServer() {
  185. webServer=$(whiptail --title "Servidor Web" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge el servidor web que quieres usar:" 20 70 2 \
  186. "Apache" "Instalar el servidor web Apache2" ON \
  187. "Nginx" "Instalar el servidor web Nginx" OFF \
  188. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  189. if [ $? -ne 0 ]; then
  190. printf "\nERROR:\tInstalación interrumpida por el usuario.\n"
  191. exit 2
  192. fi
  193. # Preguntar otras opciones de configuración
  194. comprobarHostname
  195. case $webServer in
  196. Apache)
  197. printf " Apache..."
  198. instalarApache
  199. ;;
  200. Nginx)
  201. printf " Nginx..."
  202. instalarNginx
  203. ;;
  204. *)
  205. printf "\nERROR:\tError interno (selección de web server).\n"
  206. exit 1
  207. ;;
  208. esac
  209. }
  210. instalarApache() {
  211. if [ $debianOS = true ];then
  212. result=$(apt-get -q -y install apache2 2>&1)
  213. if [ $? -ne 0 ]; then
  214. printf "\nERROR:\tError al instalar apache2.\n"
  215. printf "Detalles:\n$result\n"
  216. exit 1
  217. fi
  218. elif [ $rhelOS = true ]; then
  219. result=$(yum -y install httpd 2>&1)
  220. if [ $? -ne 0 ]; then
  221. printf "\nERROR:\tError al instalar apache2.\n"
  222. printf "Detalles:\n$result\n"
  223. exit 1
  224. fi
  225. else
  226. printf "\nERROR:\tError interno (instalación apache).\n"
  227. exit 1
  228. fi
  229. }
  230. instalarNginx() {
  231. if [ $debianOS = true ];then
  232. result=$(apt-get -q -y install nginx 2>&1)
  233. if [ $? -ne 0 ]; then
  234. printf "\nERROR:\tError al instalar apache2.\n"
  235. printf "Detalles:\n$result\n"
  236. exit 1
  237. fi
  238. elif [ $rhelOS = true ]; then
  239. # Hay que instalar primero otro repositorio
  240. result=$(yum -y install nginx 2>&1)
  241. if [ $? -ne 0 ]; then
  242. printf "\nERROR:\tError al instalar apache2.\n"
  243. printf "Detalles:\n$result\n"
  244. exit 1
  245. fi
  246. else
  247. printf "\nERROR:\tError interno (instalación apache).\n"
  248. exit 1
  249. fi
  250. }
  251. instalarDatabase() {
  252. if [ $debianOS = true ]; then
  253. database=$(whiptail --title "Base de Datos" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge la base de datos que quieres usar:" 20 70 2 \
  254. "MySQL" "Instalar la base de datos MySQL (no uso comercial)" ON \
  255. "MariaDB" "Instalar la base de datos MariaDB (fork de MySQL)" OFF \
  256. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  257. if [ $? -ne 0 ]; then
  258. printf "\nERROR:\tInstalación interrumpida por el usuario.\n"
  259. exit 2
  260. fi
  261. # Preguntar otras opciones de configuración
  262. case $database in
  263. MySQL)
  264. printf " MySQL..."
  265. instalarMySQL
  266. ;;
  267. MariaDB)
  268. printf " MariaDB..."
  269. instalarMariaDB
  270. ;;
  271. *)
  272. printf "\nERROR:\tError interno (selección de base de datos).\n"
  273. exit 1
  274. ;;
  275. esac
  276. elif [ $rhelOS = true ]; then
  277. whiptail --title "Base de Datos" --yesno "Para su distribucion $OS $DIST $REV, sólo está disponible la base de datos MariaDB." --yes-button "Continuar" --no-button "Salir" 20 70
  278. if [ $? -ne 0 ]; then
  279. printf "\nERROR:\tInstalación interrumpida por el usuario.\n"
  280. exit 2
  281. fi
  282. printf " MariaDB.."
  283. instalarMariaDB
  284. else
  285. printf "\nERROR:\tError interno (instalación Base de Datos).\n"
  286. exit 1
  287. fi
  288. }
  289. instalarMySQL() {
  290. if [ $debianOS = true ];then
  291. result=$(apt-get -q -y install mysql-server mysql-client 2>&1)
  292. if [ $? -ne 0 ]; then
  293. printf "\nERROR:\tError al instalar MySQL.\n"
  294. printf "Detalles:\n$result\n"
  295. exit 1
  296. fi
  297. elif [ $rhelOS = true ]; then
  298. # MySQL no disponible en RHEL. 2 opciones:
  299. # 1) Instalar un repositorio adicional
  300. # 2) No instalar MySQL en distribuciones RHEL
  301. printf "\nERROR:\tRHEL no incluye MySQL en sus repositorios.\n"
  302. exit 1
  303. else
  304. printf "\nERROR:\tError interno (instalación MySQL).\n"
  305. exit 1
  306. fi
  307. }
  308. instalarMariaDB() {
  309. if [ $debianOS = true ];then
  310. result=$(apt-get -q -y install mariadb-server mariadb-client 2>&1)
  311. if [ $? -ne 0 ]; then
  312. printf "\nERROR:\tError al instalar MariaDB.\n"
  313. printf "Detalles:\n$result\n"
  314. exit 1
  315. fi
  316. elif [ $rhelOS = true ]; then
  317. result=$(yum -y install mariadb-server 2>&1)
  318. if [ $? -ne 0 ]; then
  319. printf "\nERROR:\tError al instalar MariaDB.\n"
  320. printf "Detalles:\n$result\n"
  321. exit 1
  322. fi
  323. else
  324. printf "\nERROR:\tError interno (instalación MariaDB).\n"
  325. exit 1
  326. fi
  327. }
  328. # Comprobamos
  329. comprobarRoot
  330. OSInfo
  331. comprobarDependencias
  332. # Bienvenida
  333. mostrarBienvenida
  334. # Mejora: instalación express vs instalación avanzada
  335. # Selección de componentes
  336. mostrarComponentes
  337. # Pre-configuración
  338. # Habilitar cortafuegos
  339. # Instalación
  340. # Cuando funcionen todos los instaladores, cambiarlo por variables de estado e instalar en este punto
  341. # whiptail --gauge
  342. # Configuración
  343. # Configuración Apache
  344. # Virtual Hosts
  345. # Configuración Database
  346. # Configuración Segura
  347. # Configuración PHP
  348. # cgi.fix_pathinfo=0
  349. # Configurar máximo de subida de archivos
  350. # Arrancar y habilitar todos los servicios (SystemD, Service o SystemV)
  351. # Añadir reglas del cortafuegos
  352. # Configuración SSL/TLS
  353. # Generar certificados
  354. # Configurar certificados
  355. # Configuración MediWiki
  356. # Configuración Moodle
  357. # Autodestrucción
  358. {
  359. for i in $(seq 0 5 50); do
  360. sleep 0.1
  361. echo $i
  362. done
  363. } | whiptail --gauge "Autodestrucción..." 7 70 0
  364. {
  365. for i in $(seq 50 5 100); do
  366. sleep 0.1
  367. echo $i
  368. done
  369. } | whiptail --gauge "Autopulverización..." 7 70 50